.TH Multi 3 - 
.SH CLASS
Multi
.SH PUBLIC BASE CLASSES
.in 4
.B
Object
.in 7
.fi


.SH DESCRIPTION
.fi

Almost a dummy class.
Will be used for the implementation of multiple simultaneous connections
someday.
 
.SH PROTECTED MEMBERS

.in 4
.B

String sender() const
.in 7
.fi
SU name, the caller of the function. 
.in 4
.B

void setSender(Agent* agent)
.in 7
.fi
Called in MultiPtr::op->() and <derived>Message::run() to update sender(). 

.SH PUBLIC CONSTRUCTORS AND CONVERSIONS
.in 4
.B

 Multi()
.in 7
.fi


.SH FILE
multi.hxx
.TH Multi 3 - 
.SH CLASS
Multi
.SH PUBLIC BASE CLASSES
.in 4
.B
Object
.in 7
.fi


.SH DESCRIPTION
.fi


THIS IS AN OUT-OF-DATE PROTOTYPE OF CLASS Multi:

Application code should be independent of multiple/single connections.

Each object that sometimes may support multiple connections
should be derived from class Multi.
(To make things simple, Runner is derived from Multi.)
A multi is the manages instance of a class derived from Multi.
A connection is a cloned instance of the same class.
The initialization of its Multi part determines if the instance
supports multiple connections or not: 

     Multi(n)

where n > 0 allows n simultaneous connections to be created at run
time.  0 or no explicit initialization means no multiple connections.

Each derived Multi should redefine clone() to return
pointer to a free-store copy of itself, a new connection object.
clone() functions should use the copy constructor C::C(const C& m),
where m is the multi instance.
All other constructors are used to construct multi objects.

.SH BUGS
clone() should be abstract (= 0;) !
 
.SH PUBLIC MEMBERS

.in 4
.B

void* newConnection(ConnectionId& c)
.in 7
.fi
Return a new connection instance, c will be its id. Return this if no new connection can be created. 
.in 4
.B

void* connection(ConnectionId c)
.in 7
.fi
Returns the connection c, or this if unknown ConnectionId. 
.in 4
.B

void deleteConnection(ConnectionId )
.in 7
.fi
Delete a connection; no effect if ConnectionId refers to multi. 
.in 4
.B

virtual void* clone()
.in 7
.fi
Create and return a free-store  copy of this, created  using the copy constructor. Must be redefined. 
.in 4
.B

boolean isMulti()
.in 7
.fi
True if this the multi instance, false for connections. 
.SH PROTECTED MEMBERS

.in 4
.B

ConnectionId conId
.in 7
.fi
ConnectionId of this. 
.in 4
.B

Multi** connections
.in 7
.fi
 
.in 4
.B

sint32 maxConnectionNumber
.in 7
.fi
Max number of connections, excluding multi itself. 
.in 4
.B

String sender() const
.in 7
.fi
SU name. 

.SH PUBLIC CONSTRUCTORS AND CONVERSIONS
.in 4
.B

 Multi(sint32 maxConns = 0)
.in 7
.fi
Max number of dynamic connection, default is none but the multi instance.  1 does not make sense: if maxConns > 0, multi instance is not used (except for constructing new connection instances). 

.SH FILE
multi.hxx
